# 创建、修改、暂存和提交
## 创建
要将现有的软件程序纳入git管理，首先是创建版本库（或称存储库）：  
选中要管理的工程文件夹，右键选择“Git 在这里创建版本库”，点击“确定”，git就会在工程目录下创建“.git”文件夹，一个空白的版本库就创建成功。 
## 修改  
在工程目录下，右键选择“TortoiseGit”，在“TortoiseGit”下选择“检查已修改”，会打开一个窗口来显示从上次提交到现在的所有修改。  
双击文件可以查看修改的内容。  
上一步创建了空白的版本库，所以这里是工程目录下的所有文件。  
### 忽略
并不是所有的文件都需要纳入Git管理，有些文件与源代码无关，只是编译生成的中间文件或者用户个人的配置，纳入管理反而增加存储库的内存。  
这里拿Keil的工程举例：  
![](./hello_struct.png)  
“./objects”文件夹下编译生成的中间文件（.o、.d、.crf）是用不到版本管理的。但是生成的hex文件**可以选择**记录。“./listing”下的map文件也是用不到的。  
用户自己的uvguix文件，不会影响编译结果，也没必要管理。  
我们通过创建.gitignore文件，确定工作目录下哪些文件要纳入管理，哪些文件要忽略掉。  
举例：在Hello目录下创建 “.gitignore” 文件，将./objects文件夹下编译生成的中间文件忽略掉，但是保留生成的hex文件。内容如下：
```
#这是注释
#忽略整个listing文件夹
/listing
#忽略某个文件夹下的所有文件
/objects/*
#在上面基础上将hex文件纳入管理（可选）
!/objects/*.hex
#忽略keil的用户uvguix文件
*.uvguix.*
#忽略JLinkLog.txt文件
JLinkLog.txt
```
现在在“检查已修改”窗口，点击“刷新”按钮，./objects文件夹下只剩hex文件，./listing文件夹消失，uvguix文件消失。  
## 暂存和提交  
### 暂存
在其他Git客户端中可能有暂存的概念，它们提交的过程为：修改 >> 暂存 >> 提交。  
暂存主要用于分批提交，比如已经开发了A、B两个功能，想要把A、B分开提交，可以先把A的文件放在暂存区，然后提交。再把B放到暂存区，然后提交。  
TortoiseGitz支持勾选文件提交，因此用不到暂存功能，它的提交过程为：修改 >> 提交。  
### 提交
紧跟上面的操作，点击“提交”，弹出提交窗口： 
![](./hello_submit.png) 
最上面是选择提交到哪个分支，现在只有“master”分支。  
然后是本次提交的日志信息，日志信息必须写，不写提交不了。日志信息应尽可能详细，和之前的readme.txt一样。
下面选择要提交的文件，这里我们点击“全部”。
最后点击提交。
## 贮藏更改
有些情况下，正在开发的功能被打断，需要做其他工作,例如紧急修复BUG。这时需要保留已经更改的代码， “检查已修改” >> 贮藏 >> 填写贮藏日志 >> 确定  
其他工作忙完后，弹出贮藏
